﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using TMPro;
using UnityEngine;
using UnityEngine.AI;
using UnityEngine.EventSystems;
using UnityEngine.UI;

public class ItemSpawner : Mod
{
    AssetBundle asset;
    Canvas menu;
    public static ItemSpawner instance;

    GameObject ItemPrefabEntry;
    string gameitems_searchterm;
    string moddeditems_searchterm;
    string CurrentTab = "GameItems";
    Item_Base CurrentItem;
    int CurrentAmount;
    bool isShown;
    KeyCode menuKey = KeyCode.F8;

    TMP_InputField game_amountinputfield;
    TMP_InputField modded_amountinputfield;

    public IEnumerator Start()
    {
        instance = this;
        AssetBundleCreateRequest request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("itemspawner.assets"));
        yield return request;
        asset = request.assetBundle;
        menu = Instantiate(asset.LoadAsset<GameObject>("ItemSpawnerCanvas"), transform).GetComponent<Canvas>();
        menu.transform.Find("Background").Find("Tabs").Find("GameItems").GetComponent<Button>().onClick.AddListener(() => SelectTab("GameItems"));
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("Searchbar").GetComponent<TMP_InputField>().onValueChanged.AddListener((t) => { gameitems_searchterm = t; InitGameItemsTab(); });
        menu.transform.Find("Background").Find("Tabs").Find("ModdedItems").GetComponent<Button>().onClick.AddListener(() => SelectTab("ModdedItems"));
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("Searchbar").GetComponent<TMP_InputField>().onValueChanged.AddListener((t) => { moddeditems_searchterm = t; InitModdedItemsTab(); });

        menu.transform.Find("Background").Find("Topbar").Find("CloseButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            isShown = false;
            menu.GetComponent<CanvasGroup>().alpha = isShown ? 1 : 0;
            menu.GetComponent<CanvasGroup>().interactable = isShown;
            menu.GetComponent<CanvasGroup>().blocksRaycasts = isShown;
            RAPI.ToggleCursor(isShown);
        });

        game_amountinputfield = menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("AmountInputField").GetComponent<TMP_InputField>();
        modded_amountinputfield = menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("AmountInputField").GetComponent<TMP_InputField>();

        game_amountinputfield.onValueChanged.AddListener((t) => { CurrentAmount = int.Parse(t); });
        modded_amountinputfield.onValueChanged.AddListener((t) => { CurrentAmount = int.Parse(t); });

        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("GiveButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            GiveItem(CurrentItem, CurrentAmount);
        });

        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            SpawnItem(CurrentItem, CurrentAmount);
        });

        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("GiveButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            GiveItem(CurrentItem, CurrentAmount);
        });

        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            SpawnItem(CurrentItem, CurrentAmount);
        });

        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("StackButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            CurrentAmount = CurrentItem.settings_Inventory.StackSize;
            modded_amountinputfield.text = CurrentAmount.ToString();
        });

        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("StackButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            CurrentAmount = CurrentItem.settings_Inventory.StackSize;
            game_amountinputfield.text = CurrentAmount.ToString();
        });

        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("-Button").GetComponent<Button>().onClick.AddListener(() =>
        {
            CurrentAmount = int.Parse(menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("AmountInputField").GetComponent<TMP_InputField>().text) - 1;
            modded_amountinputfield.text = CurrentAmount.ToString();
        });

        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("+Button").GetComponent<Button>().onClick.AddListener(() =>
        {
            CurrentAmount = int.Parse(menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("AmountInputField").GetComponent<TMP_InputField>().text) + 1;
            modded_amountinputfield.text = CurrentAmount.ToString();
        });

        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("-Button").GetComponent<Button>().onClick.AddListener(() =>
        {
            CurrentAmount = int.Parse(menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("AmountInputField").GetComponent<TMP_InputField>().text) - 1;
            game_amountinputfield.text = CurrentAmount.ToString();
        });

        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("+Button").GetComponent<Button>().onClick.AddListener(() =>
        {
            CurrentAmount = int.Parse(menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("AmountInputField").GetComponent<TMP_InputField>().text) + 1;
            game_amountinputfield.text = CurrentAmount.ToString();
        });

        menu.transform.Find("Background").Find("Tabs").Find("Animals").GetComponent<Button>().onClick.AddListener(() => SelectTab("Animals"));
        menu.transform.Find("Background").Find("Tabs").Find("Islands").GetComponent<Button>().onClick.AddListener(() => SelectTab("Islands"));
        ItemPrefabEntry = asset.LoadAsset<GameObject>("ItemSlot");
        SelectTab("GameItems");

        menu.transform.Find("Background").Find("Menus").Find("Animals").Find("KillButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            Network_Entity[] array = FindObjectsOfType<Network_Entity>();
            Network_Entity currentEntity = null;
            float currentDistance = 999999f;
            foreach (Network_Entity network_Entity in array)
            {
                if (network_Entity.entityType == EntityType.Player || network_Entity.IsDead) { continue; }
                float distance = Vector3.Distance(RAPI.GetLocalPlayer().transform.position, network_Entity.transform.position);
                if (distance < currentDistance)
                {
                    currentDistance = distance;
                    currentEntity = network_Entity;
                }
            }
            if (currentEntity != null)
            {
                try
                {
                    ComponentManager<Network_Host>.Value.DamageEntity(currentEntity, currentEntity.transform, 9999f, currentEntity.transform.position, Vector3.up, EntityType.Player);
                    FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Successfully killed nearest entity (" + currentEntity.name + ")!", 3, HNotify.CheckSprite);
                }
                catch { }
            }
            else
            {
                FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "There is no nearby animals!", 3, HNotify.ErrorSprite);
            }

        });

        menu.transform.Find("Background").Find("Menus").Find("Islands").Find("RemoveButton").GetComponent<Button>().onClick.AddListener(() =>
        {
            ComponentManager<ChunkManager>.Value.ClearAllChunkPoints();
            FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Successfully cleared all landmarks!", 3, HNotify.CheckSprite);
        });

        InitAnimalsTab();
        InitIslandsTab();

        menu.GetComponent<CanvasGroup>().alpha = 0;
        menu.GetComponent<CanvasGroup>().interactable = false;
        menu.GetComponent<CanvasGroup>().blocksRaycasts = false;

        Debug.Log("ItemSpawner has been loaded!");
    }

    public void InitAnimalsTab()
    {
        Transform content = menu.transform.Find("Background").Find("Menus").Find("Animals").Find("ScrollView").Find("Viewport").Find("Content");

        List<AI_NetworkBehaviourType> currentlySupported = new List<AI_NetworkBehaviourType>();

        content.Find("Shark").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.Shark));
        currentlySupported.Add(AI_NetworkBehaviourType.Shark);
        content.Find("Seagull").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnSeagull());
        content.Find("StoneBird").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.StoneBird));
        currentlySupported.Add(AI_NetworkBehaviourType.StoneBird);
        content.Find("Pufferfish").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.PufferFish));
        currentlySupported.Add(AI_NetworkBehaviourType.PufferFish);
        content.Find("Llama").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.Llama));
        currentlySupported.Add(AI_NetworkBehaviourType.Llama);
        content.Find("Goat").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.Goat));
        currentlySupported.Add(AI_NetworkBehaviourType.Goat);
        content.Find("Chicken").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.Chicken));
        currentlySupported.Add(AI_NetworkBehaviourType.Chicken);
        content.Find("Boar").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.Boar));
        currentlySupported.Add(AI_NetworkBehaviourType.Boar);
        content.Find("Rat").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.Rat));
        currentlySupported.Add(AI_NetworkBehaviourType.Rat);
        content.Find("Bear").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.Bear));
        currentlySupported.Add(AI_NetworkBehaviourType.Bear);
        content.Find("MamaBear").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.MamaBear));
        currentlySupported.Add(AI_NetworkBehaviourType.MamaBear);
        content.Find("BugSwarm").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(AI_NetworkBehaviourType.BugSwarm_Bee));
        currentlySupported.Add(AI_NetworkBehaviourType.BugSwarm_Bee);

        GameObject AnimalPrefab = asset.LoadAsset<GameObject>("AnimalSlot");
        foreach (AI_NetworkBehaviourType animal in typeof(AI_NetworkBehaviourType).GetEnumValues())
        {
            if (animal == AI_NetworkBehaviourType.None || animal == AI_NetworkBehaviourType.TEST) { continue; }
            if (!currentlySupported.Contains(animal))
            {
                GameObject t = Instantiate(AnimalPrefab, content);
                t.name = animal.ToString();

                Sprite sprite = asset.LoadAsset<Sprite>(animal.ToString());
                if (sprite != null)
                {
                    t.transform.Find("Icon").GetComponent<Image>().sprite = sprite;
                }
                if(animal == AI_NetworkBehaviourType.StoneBird_Caravan)
                {
                    t.transform.Find("TopBar").Find("Label").GetComponent<TextMeshProUGUI>().fontSize = 15f;
                }
                t.transform.Find("TopBar").Find("Label").GetComponent<TextMeshProUGUI>().text = animal.ToString();
                t.transform.Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnAnimal(animal));
            }
        }
    }

    public void InitIslandsTab()
    {
        Transform content = menu.transform.Find("Background").Find("Menus").Find("Islands").Find("ScrollView").Find("Viewport").Find("Content");

        List<ChunkPointType> currentlySupported = new List<ChunkPointType>();

        content.Find("SmallIsland").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnLandmark(ChunkPointType.Landmark_Small));
        currentlySupported.Add(ChunkPointType.Landmark_Small);
        content.Find("LargeIsland").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnLandmark(ChunkPointType.Landmark_Big));
        currentlySupported.Add(ChunkPointType.Landmark_Big);
        content.Find("FloatingRaft").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnLandmark(ChunkPointType.Landmark_FloatingRaft));
        currentlySupported.Add(ChunkPointType.Landmark_FloatingRaft);
        content.Find("BalboaIsland").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnLandmark(ChunkPointType.Landmark_Balboa));
        currentlySupported.Add(ChunkPointType.Landmark_Balboa);
        content.Find("BoatIsland").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnLandmark(ChunkPointType.Landmark_Boat));
        currentlySupported.Add(ChunkPointType.Landmark_Boat);
        content.Find("PilotIsland").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnLandmark(ChunkPointType.Landmark_Pilot));
        currentlySupported.Add(ChunkPointType.Landmark_Pilot);
        content.Find("RadioTower").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnLandmark(ChunkPointType.Landmark_RadioTower));
        currentlySupported.Add(ChunkPointType.Landmark_RadioTower);
        content.Find("Vasagatan").Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnLandmark(ChunkPointType.Landmark_Vasagatan));
        currentlySupported.Add(ChunkPointType.Landmark_Vasagatan);

        GameObject IslandPrefab = asset.LoadAsset<GameObject>("IslandSlot");
        foreach (ChunkPointType cpt in typeof(ChunkPointType).GetEnumValues())
        {
            if (cpt == ChunkPointType.None || cpt == ChunkPointType.Landmark_Test) { continue; }
            if (!currentlySupported.Contains(cpt))
            {
                GameObject t = Instantiate(IslandPrefab, content);
                t.name = cpt.ToString();
                Sprite sprite = asset.LoadAsset<Sprite>(cpt.ToString().ToLower().Replace("landmark_", ""));
                if (sprite != null)
                {
                    t.transform.Find("Icon").GetComponent<Image>().sprite = sprite;
                }
                t.transform.Find("TopBar").Find("Label").GetComponent<TextMeshProUGUI>().text = cpt.ToString().ToLower().Replace("landmark_", "");
                t.transform.Find("SpawnButton").GetComponent<Button>().onClick.AddListener(() => SpawnLandmark(cpt));
            }
        }

    }

    public void SpawnLandmark(ChunkPointType cpt)
    {
        if (!Semih_Network.IsHost)
        {
            FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "You are not the host!", 3, HNotify.ErrorSprite);
            return;
        }
        SO_ChunkSpawnRuleAsset ruleFromPointType = ComponentManager<ChunkManager>.Value.GetRuleFromPointType(cpt);
        if (ruleFromPointType)
        {
            int value = 200;
            switch (cpt)
            {
                case ChunkPointType.Landmark_Balboa:
                    value = 400;
                    break;
            }

            ComponentManager<ChunkManager>.Value.AddChunkPointCheat(cpt, Raft.direction * value);
            FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "Landmark successfully spawned!", 3, HNotify.CheckSprite);
        }
        else
        {
            FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "This island is in the game but isn't fully implemented currently!", 3, HNotify.ErrorSprite);
        }
    }

    [ConsoleCommand(name: "itemspawner_menu",docs: "Toggle the itemspawner menu.")]
    public static void itemspawnermenu()
    {
        instance.isShown = !instance.isShown;
        instance.SelectTab(instance.CurrentTab);
        instance.menu.GetComponent<CanvasGroup>().alpha = instance.isShown ? 1 : 0;
        instance.menu.GetComponent<CanvasGroup>().interactable = instance.isShown;
        instance.menu.GetComponent<CanvasGroup>().blocksRaycasts = instance.isShown;
        RAPI.ToggleCursor(instance.isShown);
    }

    public void Update()
    {
        if (RAPI.IsCurrentSceneMainMenu() || !asset) { return; }
        if (Input.GetKeyDown(menuKey) || (Input.GetKeyDown(KeyCode.Escape) && isShown))
        {
            isShown = !isShown;
            SelectTab(CurrentTab);
            menu.GetComponent<CanvasGroup>().alpha = isShown ? 1 : 0;
            menu.GetComponent<CanvasGroup>().interactable = isShown;
            menu.GetComponent<CanvasGroup>().blocksRaycasts = isShown;
            RAPI.ToggleCursor(isShown);
        }

        if (isShown)
        {
            if (!modded_amountinputfield || !game_amountinputfield) { return; }
            if (CurrentAmount <= 0)
            {
                CurrentAmount = 1;
                modded_amountinputfield.text = CurrentAmount.ToString();
                game_amountinputfield.text = CurrentAmount.ToString();
            }
            if (modded_amountinputfield.text == "")
            {
                modded_amountinputfield.text = CurrentAmount.ToString();
            }

            if (game_amountinputfield.text == "")
            {
                game_amountinputfield.text = CurrentAmount.ToString();
            }
        }
    }

    public void SpawnSeagull()
    {
        if (!Semih_Network.IsHost)
        {
            FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "You are not the host!", 3, HNotify.ErrorSprite);
            return;
        }
        GameModeValueManager.GetCurrentGameModeValue().seagullVariables.shouldSpawn = true;
        ComponentManager<Network_Host_Entities>.Value.CreateSeagull(RAPI.GetLocalPlayer().transform.position + RAPI.GetLocalPlayer().transform.forward * 2, SaveAndLoad.GetUniqueObjectIndex(), SaveAndLoad.GetUniqueObjectIndex(), NetworkUpdateManager.GetUniqueBehaviourIndex());
    }

    public void SpawnAnimal(AI_NetworkBehaviourType animal)
    {
        if (!Semih_Network.IsHost)
        {
            FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "You are not the host!", 3, HNotify.ErrorSprite);
            return;
        }

        if (RAPI.GetLocalPlayer().transform.ParentedToRaft())
        {
            if (animal == AI_NetworkBehaviourType.Chicken || animal == AI_NetworkBehaviourType.Goat || animal == AI_NetworkBehaviourType.Llama)
            {
                AI_NetworkBehaviour_Domestic spawned = ComponentManager<Network_Host_Entities>.Value.CreateAINetworkBehaviour(animal, RAPI.GetLocalPlayer().transform.position + RAPI.GetLocalPlayer().transform.forward * 2) as AI_NetworkBehaviour_Domestic;
                spawned.QuickTameLate();
            }
            else if (animal == AI_NetworkBehaviourType.Shark || animal == AI_NetworkBehaviourType.PufferFish || animal == AI_NetworkBehaviourType.BugSwarm_Bee)
            {
                AI_NetworkBehaviour spawned = ComponentManager<Network_Host_Entities>.Value.CreateAINetworkBehaviour(animal, RAPI.GetLocalPlayer().transform.position + RAPI.GetLocalPlayer().transform.forward * 2);
            }
            else
            {
                FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.normal, "This animal can only be spawned on an island!", 5, HNotify.ErrorSprite);
            }
        }
        else
        {
            try
            {
                AI_NetworkBehaviour_Domestic spawned = ComponentManager<Network_Host_Entities>.Value.CreateAINetworkBehaviour(animal, RAPI.GetLocalPlayer().transform.position + RAPI.GetLocalPlayer().transform.forward * 2) as AI_NetworkBehaviour_Domestic;
                spawned.QuickTameLate();
            }
            catch
            {
                AI_NetworkBehaviour spawned = ComponentManager<Network_Host_Entities>.Value.CreateAINetworkBehaviour(animal, RAPI.GetLocalPlayer().transform.position + RAPI.GetLocalPlayer().transform.forward * 2);
            }
        }
    }


    public void GiveItem(Item_Base item, int amount)
    {
        RAPI.GetLocalPlayer().Inventory.AddItem(item.UniqueName, amount);
    }

    public void SpawnItem(Item_Base item, int amount)
    {
        Network_Player player = RAPI.GetLocalPlayer();
        Helper.DropItem(new ItemInstance(item, amount, item.MaxUses), player.transform.position, player.CameraTransform.forward, player.transform.ParentedToRaft());
    }

    public void SelectTab(string name)
    {
        CurrentTab = name;
        switch (name)
        {
            case "GameItems":
                gameitems_searchterm = "";
                menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("Searchbar").GetComponent<TMP_InputField>().text = "";
                menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("Searchbar").GetComponent<TMP_InputField>().OnDeselect(null);
                InitGameItemsTab();
                break;
            case "ModdedItems":
                moddeditems_searchterm = "";
                menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("Searchbar").GetComponent<TMP_InputField>().text = "";
                menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("Searchbar").GetComponent<TMP_InputField>().OnDeselect(null);
                InitModdedItemsTab();
                break;
        }
        menu.transform.Find("Background").Find("Menus").Find("Animals").GetComponentsInChildren<EventTrigger>().ToList().ForEach((t) => t.transform.Find("SpawnButton").gameObject.SetActive(false));
        menu.transform.Find("Background").Find("Menus").Find("Islands").GetComponentsInChildren<EventTrigger>().ToList().ForEach((t) => t.transform.Find("SpawnButton").gameObject.SetActive(false));
        foreach (Transform t in menu.transform.Find("Background").Find("Menus"))
        {
            t.gameObject.SetActive(t.transform.name == name);
        }
    }

    public void InitGameItemsTab()
    {
        ResetGameItemsCurrentItem();
        GameObject content = menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("ScrollView").Find("Viewport").Find("Content").gameObject;
        foreach (Transform t in content.transform)
        {
            Destroy(t.gameObject);
        }
        foreach (Item_Base item in ItemManager.GetAllItems())
        {
            if (item.UniqueIndex <= 500)
            {
                if (item.settings_Inventory.DisplayName.ToLower().Contains(gameitems_searchterm.ToLower()) && item.settings_Inventory.DisplayName.ToLower() != "an item")
                {
                    GameObject itemInstance = Instantiate(ItemPrefabEntry, content.transform);
                    itemInstance.transform.Find("Icon").GetComponent<Image>().sprite = item.settings_Inventory.Sprite;
                    itemInstance.GetComponent<Button>().onClick.AddListener(() =>
                    {
                        foreach (Transform t in content.transform)
                        {
                            t.GetComponent<Button>().interactable = true;
                        }
                        itemInstance.GetComponent<Button>().interactable = false;
                        SelectGameItemsCurrentItem(item);
                    });
                }
            }
        }
    }

    public void SelectGameItemsCurrentItem(Item_Base item)
    {
        CurrentItem = item;
        CurrentAmount = 1;
        game_amountinputfield.text = CurrentAmount.ToString();
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("Name").GetComponent<TextMeshProUGUI>().text = "Name : <color=#bdc3c7>" + item.settings_Inventory.DisplayName + "</color>";
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("Description").GetComponent<TextMeshProUGUI>().text = "Description : <color=#bdc3c7>" + item.settings_Inventory.Description + "</color>";
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("StackSize").GetComponent<TextMeshProUGUI>().text = "Stack Size : <color=#bdc3c7>" + item.settings_Inventory.StackSize.ToString() + "</color>";
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("Sprite").GetComponent<Image>().sprite = item.settings_Inventory.Sprite;
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").GetComponent<CanvasGroup>().interactable = true;
    }

    public void ResetGameItemsCurrentItem()
    {
        CurrentItem = null;
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("Name").GetComponent<TextMeshProUGUI>().text = "Name : <color=#bdc3c7>Select an item...</color>";
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("Description").GetComponent<TextMeshProUGUI>().text = "Description : <color=#bdc3c7>Select an item...</color>";
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("StackSize").GetComponent<TextMeshProUGUI>().text = "Stack Size : <color=#bdc3c7>Select an item...</color>";
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").Find("Sprite").GetComponent<Image>().sprite = ItemManager.GetItemByIndex(236).settings_Inventory.Sprite;
        menu.transform.Find("Background").Find("Menus").Find("GameItems").Find("GiveCategory").GetComponent<CanvasGroup>().interactable = false;
    }

    public void InitModdedItemsTab()
    {
        ResetModdedItemsCurrentItem();
        GameObject content = menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("ScrollView").Find("Viewport").Find("Content").gameObject;
        foreach (Transform t in content.transform)
        {
            Destroy(t.gameObject);
        }
        foreach (Item_Base item in ItemManager.GetAllItems())
        {
            if (item.UniqueIndex > 500)
            {
                if (item.settings_Inventory.DisplayName.ToLower().Contains(moddeditems_searchterm.ToLower()))
                {
                    GameObject itemInstance = Instantiate(ItemPrefabEntry, content.transform);
                    itemInstance.transform.Find("Icon").GetComponent<Image>().sprite = item.settings_Inventory.Sprite;
                    itemInstance.GetComponent<Button>().onClick.AddListener(() =>
                    {
                        foreach (Transform t in content.transform)
                        {
                            t.GetComponent<Button>().interactable = true;
                        }
                        itemInstance.GetComponent<Button>().interactable = false;
                        SelectModdedItemsCurrentItem(item);
                    });
                }
            }
        }
    }

    public void SelectModdedItemsCurrentItem(Item_Base item)
    {
        CurrentItem = item;
        CurrentAmount = 1;
        modded_amountinputfield.text = CurrentAmount.ToString();
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("Name").GetComponent<TextMeshProUGUI>().text = "Name : <color=#bdc3c7>" + item.settings_Inventory.DisplayName + "</color>";
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("Description").GetComponent<TextMeshProUGUI>().text = "Description : <color=#bdc3c7>" + item.settings_Inventory.Description + "</color>";
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("StackSize").GetComponent<TextMeshProUGUI>().text = "Stack Size : <color=#bdc3c7>" + item.settings_Inventory.StackSize.ToString() + "</color>";
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("Sprite").GetComponent<Image>().sprite = item.settings_Inventory.Sprite;
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").GetComponent<CanvasGroup>().interactable = true;
    }

    public void ResetModdedItemsCurrentItem()
    {
        CurrentItem = null;
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("Name").GetComponent<TextMeshProUGUI>().text = "Name : <color=#bdc3c7>Select an item...</color>";
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("Description").GetComponent<TextMeshProUGUI>().text = "Description : <color=#bdc3c7>Select an item...</color>";
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("StackSize").GetComponent<TextMeshProUGUI>().text = "Stack Size : <color=#bdc3c7>Select an item...</color>";
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").Find("Sprite").GetComponent<Image>().sprite = ItemManager.GetItemByIndex(236).settings_Inventory.Sprite;
        menu.transform.Find("Background").Find("Menus").Find("ModdedItems").Find("GiveCategory").GetComponent<CanvasGroup>().interactable = false;
    }

    public void OnModUnload()
    {
        if (asset)
        {
            asset.Unload(true);
        }
        Debug.Log("ItemSpawner has been unloaded!");
    }
}